SystemOrganization addCategory: #Matcher!
SystemOrganization addCategory: #'Matcher-Test'!

TestCase subclass: #MatcherTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Matcher-Test'!

!MatcherTest methodsFor: 'as yet unclassified' stamp: 'HectorGonzalez 4/7/2013 17:38'!
testPersonCreation

| skillColl locColl person|
skillColl := OrderedCollection new.
locColl := OrderedCollection new.

person := MatcherPerson withSkillsCollection: skillColl locationCollection: locColl firstName: 'Test' lastName: 'Techer' address: '1 Tech Way' city: 'Tech City' state: 'PA' zip: '19191' phone: '5555551212'.

self assert: 'Test Techer'  = person fullName.
self assert: '1 Tech Way, Tech City, PA 19191'  = person fullAddress.! !

!MatcherTest methodsFor: 'as yet unclassified' stamp: 'HectorGonzalez 4/1/2013 00:07'!
testTechCreation
| skillColl locColl techTicketApp certColl tech |

techTicketApp := TechTicketApp new.
skillColl := OrderedCollection new.
locColl := OrderedCollection new.
certColl := #(ccna microsoft) asOrderedCollection.

skillColl add: (TechSkill withName: 'Testing' level: 2 description: 'This is a level 2 of 10 skill').
locColl add: (TechLocation newWithName: 'Test City' address: '1 Test Street' city: 'Test City' state: 'FL' additionalInfo: 'A place to test').

tech := (Tech withSkillsCollection: skillColl locationCollection: locColl firstName: 'Test' lastName: 'Techer' address: '1 Tech Way' city: 'Tech City' state: 'PA' zip: '19191' phone: '5555551212'  certificationsCollection: certColl).

techTicketApp addTech: tech.

self assert: true = (tech hasCertification: #ccna).! !

!MatcherTest methodsFor: 'as yet unclassified' stamp: 'HectorGonzalez 4/7/2013 18:06'!
testTicketCreation
| skillColl locColl techTicketApp certColl tech |

techTicketApp := TechTicketApp new.
skillColl := OrderedCollection new.
locColl := OrderedCollection new.

skillColl add: (TechSkill withName: 'Testing' level: 2 description: 'This is a level 2 of 10 skill').
locColl add: (TechLocation newWithName: 'Test City' address: '1 Test Street' city: 'Test City' state: 'FL' additionalInfo: 'A place to test').

techTicketApp addTicket: (Ticket newWithDescription: 'Test Ticket' priority: 1 dueBy: (Date today) locations: locColl reqSkillsCollection: skillColl createdBy: (MatcherUser fullName: 'Pepe Smith')).

"self assert: 1 = (techTicketApp ticketCount)."! !

!MatcherTest methodsFor: 'as yet unclassified' stamp: 'HectorGonzalez 4/1/2013 22:37'!
testWorkerCreation

| skillColl locColl traitsColl worker daysAvailable |
skillColl := OrderedCollection new.
locColl := OrderedCollection new.
traitsColl := OrderedCollection new.
daysAvailable := #(monday wednesday friday) asOrderedCollection.

"changing something.. trying to commit..."

worker := Entrepreneur withSkillsCollection: skillColl locationCollection: locColl firstName: 'Test' lastName: 'Techer' address: '1 Tech Way' city: 'Tech City' state: 'PA' zip: '19191' phone: '5555551212' traits: traitsColl daysAvailable: daysAvailable.

traitsColl add:#fun.
skillColl add:#java.
locColl add:#miami.

self assert: 'Test Techer'  = worker fullName.
self assert: '1 Tech Way, Tech City, PA 19191'  = worker fullAddress.
self assert: true = (worker hasTrait: #fun).
self assert: true = (worker hasSkill: #java).
self assert: true = (worker hasLocation: #miami).
self assert: true = (worker isAvailableAt: #(wednesday friday) asOrderedCollection).
self assert: false = (worker isAvailableAt: #(thursday friday) asOrderedCollection).! !

Object subclass: #DimensionList
	instanceVariableNames: 'orderedCollection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Matcher'!

DimensionList subclass: #Certifications
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Matcher'!

!Certifications methodsFor: 'as yet unclassified' stamp: 'HectorGonzalez 4/1/2013 00:16'!
label
	^'Certifications'! !

DimensionList subclass: #DaysAvailable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Matcher'!

!DaysAvailable methodsFor: 'as yet unclassified' stamp: 'HectorGonzalez 4/1/2013 00:18'!
label
	^'Days Available'! !

!DimensionList class methodsFor: 'as yet unclassified' stamp: 'HectorGonzalez 4/1/2013 00:17'!
withCollection: aCollection
	^self new withCollection: aCollection! !

!DimensionList methodsFor: 'private' stamp: 'HectorGonzalez 3/31/2013 23:55'!
dimensionIncludes: aCriteria
^orderedCollection includes: aCriteria! !

!DimensionList methodsFor: 'testing' stamp: 'HectorGonzalez 3/31/2013 23:42'!
hasA: aCriteria
^self dimensionIncludes: aCriteria! !

!DimensionList methodsFor: 'testing' stamp: 'HectorGonzalez 4/1/2013 00:13'!
hasAll: theseCriterias
theseCriterias do: [ :criteria | 
	(orderedCollection includes: criteria) ifFalse: [^false]. ].
^true
! !

!DimensionList methodsFor: 'adding' stamp: 'HectorGonzalez 4/1/2013 00:17'!
withCollection: aCollection
orderedCollection := aCollection! !

DimensionList subclass: #Locations
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Matcher'!

!Locations methodsFor: 'as yet unclassified' stamp: 'HectorGonzalez 4/1/2013 00:16'!
label
	^'Locations'! !

DimensionList subclass: #Skills
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Matcher'!

!Skills methodsFor: 'as yet unclassified' stamp: 'HectorGonzalez 4/1/2013 00:15'!
label
	^'Skills'! !

DimensionList subclass: #Traits
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Matcher'!

!Traits methodsFor: 'as yet unclassified' stamp: 'HectorGonzalez 4/1/2013 00:17'!
label
	^'Traits'! !

Object subclass: #MatcherHours
	instanceVariableNames: 'beginAvailable endAvailable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Matcher'!

MatcherHours subclass: #TechHours
	instanceVariableNames: 'onCallBegin onCallEnd'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Matcher'!

!TechHours methodsFor: 'as yet unclassified' stamp: 'MattF 3/31/2013 12:35'!
withBeginTime: aBeginTime endTime: anEndTime

beginAvailable := aBeginTime .
endAvailable := anEndTime .
onCallBegin := Time midnight.
onCallEnd := Time midnight.! !

!TechHours methodsFor: 'as yet unclassified' stamp: 'MattF 3/31/2013 12:35'!
withBeginTime: aBeginTime endTime: anEndTime onCallBeginTime: anOnCallBeginTime onCallEndTime: anOnCallEndTime

beginAvailable := aBeginTime .
endAvailable := anEndTime .
onCallBegin := anOnCallBeginTime.
onCallEnd := anOnCallEndTime.! !

Object subclass: #MatcherIssue
	instanceVariableNames: 'id locationCollection assignedPersonsCollection requiredSkillsCollection description creator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Matcher'!

!MatcherIssue methodsFor: 'as yet unclassified' stamp: 'Mattf 4/5/2013 23:05'!
id
	^ id.! !

!MatcherIssue methodsFor: 'as yet unclassified' stamp: 'Mattf 4/1/2013 17:50'!
locationCollection
	^locationCollection.! !

!MatcherIssue methodsFor: 'as yet unclassified' stamp: 'Mattf 4/1/2013 15:05'!
matches: anIssue with: aPerson
	^ self subclassResponsibility ! !

!MatcherIssue methodsFor: 'as yet unclassified' stamp: 'Mattf 4/1/2013 17:41'!
requiredSkillsCollection
	^ requiredSkillsCollection! !

MatcherIssue subclass: #Ticket
	instanceVariableNames: 'priority dueByTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Matcher'!

!Ticket class methodsFor: 'as yet unclassified' stamp: 'Mattf 4/5/2013 23:00'!
newWithDescription: desc priority: priorityNum dueBy: dueByDate locations: locColl reqSkillsCollection: reqSkillsColl createdBy: user

^ self new newWithDescription: desc priority: priorityNum dueBy: dueByDate locations: locColl reqSkillsCollection: reqSkillsColl createdBy: user

! !

!Ticket methodsFor: 'as yet unclassified' stamp: 'Mattf 4/5/2013 22:58'!
assignTech: aTech
	assignedPersonsCollection add: aTech.! !

!Ticket methodsFor: 'as yet unclassified' stamp: 'Mattf 4/1/2013 17:54'!
matches: aTicket with: aTech
"accepts a ticket object and a tech object to provide a score or true/false for how well they match up"
"not sure if this should be in its own class for a good pattern use somewhere"
| skillScore locScore tempScore tempCount |
tempScore := 0.
tempCount := (aTicket requiredSkillsCollection) size.
aTicket requiredSkillsCollection do: [:ele | (aTech hasSkill: ele) ifTrue: [tempScore := tempScore + 1]]. 
tempScore :=  tempScore / tempCount * 100. "0-100 score for skill matches"
skillScore := tempScore.

tempCount := (aTicket locationCollection) size.
aTicket locationCollection do: [:ele | (aTech hasLocation: ele) ifTrue: [tempScore := tempScore + 1]]. 
tempScore :=  tempScore / tempCount * 100. "0-100 score for loc matches"
locScore := tempScore.

"here we could put weights for items maybe the user could end up specifying??  I will use 75% skill 25% location"
tempScore := (skillScore * 0.75) + (locScore * 0.25).

^ tempScore.! !

!Ticket methodsFor: 'as yet unclassified' stamp: 'Mattf 4/5/2013 21:30'!
newWithDescription: desc priority: priorityNum dueBy: dueByDate locations: locColl reqSkillsCollection: reqSkillsColl createdBy: user

id := TechTicketApp new nextTicketId.
description := desc.
priority := priorityNum.
dueByTime := dueByDate.
locationCollection := locColl.
requiredSkillsCollection := reqSkillsColl.
creator := user.
assignedPersonsCollection := OrderedCollection new.


! !

!Ticket methodsFor: 'as yet unclassified' stamp: 'Mattf 4/5/2013 22:58'!
removeTech: aTech
	assignedPersonsCollection remove: aTech.! !

Object subclass: #MatcherLocation
	instanceVariableNames: 'name address city state additionalInfo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Matcher'!

!MatcherLocation class methodsFor: 'as yet unclassified' stamp: 'MattF 3/31/2013 01:02'!
empty

^ (MatcherLocation new) newWithName: 'Unknown' address: '' city: '' state: '' additionalInfo: 'Location has not been set'! !

!MatcherLocation class methodsFor: 'as yet unclassified' stamp: 'MattF 3/31/2013 13:04'!
newWithName: strName address: strAddress city: strCity state: strState additionalInfo: strAdditionalInfo

^ self new newWithName: strName address: strAddress city: strCity state: strState additionalInfo: strAdditionalInfo.! !

!MatcherLocation methodsFor: 'as yet unclassified' stamp: 'MattF 3/31/2013 01:00'!
newWithName: strName address: strAddress city: strCity state: strState additionalInfo: strAdditionalInfo

name := strName.
address := strAddress.
city := strCity.
state := strState.
additionalInfo := strAdditionalInfo.! !

MatcherLocation subclass: #TechLocation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Matcher'!

Object subclass: #MatcherMainApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Matcher'!

MatcherMainApp class
	instanceVariableNames: 'skillsArray issueArray personArray'!

MatcherMainApp class
	instanceVariableNames: 'skillsArray issueArray personArray'!

MatcherMainApp subclass: #TechTicketApp
	instanceVariableNames: 'ticketCollection locationCollection techCollection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Matcher'!

TechTicketApp class
	instanceVariableNames: 'instance'!

TechTicketApp class
	instanceVariableNames: 'instance'!

!TechTicketApp class methodsFor: 'as yet unclassified' stamp: 'Mattf 4/5/2013 21:14'!
new
	(instance isNil) 
		ifTrue: [instance := TechTicketApp basicNew initialize].
		^ instance.! !

!TechTicketApp methodsFor: 'as yet unclassified' stamp: 'MattF 3/31/2013 13:22'!
addTech: aTech

techCollection add: aTech.! !

!TechTicketApp methodsFor: 'as yet unclassified' stamp: 'Mattf 4/5/2013 22:59'!
addTicket: aTicket
	ticketCollection add: aTicket.! !

!TechTicketApp methodsFor: 'as yet unclassified' stamp: 'MattF 3/31/2013 12:59'!
initialize 

ticketCollection := OrderedCollection new.
locationCollection := OrderedCollection new.
techCollection := OrderedCollection new.
super initialize .! !

!TechTicketApp methodsFor: 'as yet unclassified' stamp: 'Mattf 4/5/2013 21:29'!
nextTicketId
	| newTicketNum |
	newTicketNum := 1.
	ticketCollection do: [:element | ((element id) > newTicketNum) ifTrue: [newTicketNum := (element id) +1]].
	^ newTicketNum.! !

!TechTicketApp methodsFor: 'as yet unclassified' stamp: 'HectorGonzalez 4/7/2013 18:02'!
ticketCount
	^ticketCollection size
! !

Object subclass: #MatcherPerson
	instanceVariableNames: 'skills locations fname lname address city state zip phone'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Matcher'!

MatcherPerson subclass: #Entrepreneur
	instanceVariableNames: 'traits daysAvailable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Matcher'!

!Entrepreneur class methodsFor: 'as yet unclassified' stamp: 'HectorGonzalez 4/1/2013 00:09'!
withSkillsCollection: skillsArr locationCollection: locationArr firstName: strFName lastName: strLName address: strAddress city: strCity state: strState zip: strZip phone: strPhone traits: traitsArr daysAvailable: aSetOfDaysAvailable

^ self new withSkillsCollection: skillsArr locationCollection: locationArr firstName: strFName lastName: strLName address: strAddress city: strCity state: strState zip: strZip phone: strPhone traits: traitsArr daysAvailable: aSetOfDaysAvailable.

! !

!Entrepreneur methodsFor: 'testing' stamp: 'HectorGonzalez 3/31/2013 23:49'!
hasTrait: aTrait
	^(traits hasA: aTrait).! !

!Entrepreneur methodsFor: 'testing' stamp: 'HectorGonzalez 4/1/2013 00:03'!
isAvailableAt: theseDays
	^(daysAvailable hasAll: theseDays).! !

!Entrepreneur methodsFor: 'initialize-release' stamp: 'HectorGonzalez 4/1/2013 00:19'!
withSkillsCollection: skillsArr locationCollection: locationArr firstName: strFName lastName: strLName address: strAddress city: strCity state: strState zip: strZip phone: strPhone traits: traitsArr daysAvailable: aSetOfDaysAvailable

super 	withSkillsCollection: skillsArr 
			locationCollection: locationArr 
			firstName: strFName 
			lastName: strLName 
			address: strAddress 
			city: strCity 
			state: strState 
			zip: strZip 
			phone: strPhone.

traits := Traits withCollection: traitsArr.
daysAvailable := DaysAvailable withCollection: aSetOfDaysAvailable.! !

!MatcherPerson class methodsFor: 'as yet unclassified' stamp: 'HectorGonzalez 3/31/2013 20:50'!
withSkillsCollection: skillsArr locationCollection: locationArr firstName: strFName lastName: strLName address: strAddress city: strCity state: strState zip: strZip phone: strPhone

^ self new withSkillsCollection: skillsArr locationCollection: locationArr firstName: strFName lastName: strLName address: strAddress city: strCity state: strState zip: strZip phone: strPhone.! !

!MatcherPerson methodsFor: 'accessing' stamp: 'HectorGonzalez 3/31/2013 20:57'!
fullAddress
	^ (address, ', ', city, ', ', state, ' ', zip)! !

!MatcherPerson methodsFor: 'accessing' stamp: 'HectorGonzalez 3/31/2013 20:48'!
fullName
  ^(fname, ' ', lname)! !

!MatcherPerson methodsFor: 'as yet unclassified' stamp: 'HectorGonzalez 3/31/2013 23:46'!
hasLocation: aLocation
	^(locations hasA: aLocation).! !

!MatcherPerson methodsFor: 'testing' stamp: 'HectorGonzalez 3/31/2013 23:41'!
hasSkill: aSkill
	^(skills hasA: aSkill).! !

!MatcherPerson methodsFor: 'initialize-release' stamp: 'HectorGonzalez 4/1/2013 00:19'!
withSkillsCollection:  skillsArr locationCollection:  locationArr firstName: strFName lastName: strLName address: strAddress city: strCity state: strState zip: strZip phone: strPhone
	
fname := strFName.
lname := strLName.
address := strAddress.
city := strCity.
state := strState.
zip := strZip.
phone := strPhone.

skills := Skills withCollection: skillsArr.
locations := Locations withCollection: locationArr.! !

MatcherPerson subclass: #Tech
	instanceVariableNames: 'certifications currentLocation weeklyScheduleDict exceptionScheduleDict ticketAssignmentsCollection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Matcher'!

!Tech class methodsFor: 'as yet unclassified' stamp: 'HectorGonzalez 3/31/2013 23:53'!
withSkillsCollection: skillsArr locationCollection: locationArr firstName: strFName lastName: strLName address: strAddress city: strCity state: strState zip: strZip phone: strPhone certificationsCollection: certificationsArr

^ self new withSkillsCollection: skillsArr locationCollection: locationArr firstName: strFName lastName: strLName address: strAddress city: strCity state: strState zip: strZip phone: strPhone certificationsCollection: certificationsArr.! !

!Tech methodsFor: 'as yet unclassified' stamp: 'HectorGonzalez 4/1/2013 00:00'!
hasCertification: aCertification
	^(certifications hasA: aCertification).! !

!Tech methodsFor: 'as yet unclassified' stamp: 'HectorGonzalez 4/1/2013 00:19'!
withSkillsCollection: skillsArr locationCollection: locationArr firstName: strFName lastName: strLName address: strAddress city: strCity state: strState zip: strZip phone: strPhone certificationsCollection: certificationsArr

super 	withSkillsCollection: skillsArr 
			locationCollection: locationArr 
			firstName: strFName 
			lastName: strLName 
			address: strAddress 
			city: strCity 
			state: strState 
			zip: strZip 
			phone: strPhone.

currentLocation := nil.
weeklyScheduleDict := Dictionary new.
weeklyScheduleDict at: #sunday put: OrderedCollection new. "new object for times in these days??"
weeklyScheduleDict at: #monday put: OrderedCollection new.
weeklyScheduleDict at: #tuesday put: OrderedCollection new.
weeklyScheduleDict at: #wednesday put: OrderedCollection new.
weeklyScheduleDict at: #thursday put: OrderedCollection new.
weeklyScheduleDict at: #friday put: OrderedCollection new.
weeklyScheduleDict at: #saturday put: OrderedCollection new.
exceptionScheduleDict := Dictionary new. "put hours in for symbol which is the date, maybe a time object holder??"
ticketAssignmentsCollection := OrderedCollection new.

certifications := Certifications withCollection: certificationsArr.! !

Object subclass: #MatcherScore
	instanceVariableNames: 'score scaleDictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Matcher'!

MatcherScore subclass: #TechTicketScore
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Matcher'!

Object subclass: #MatcherSkill
	instanceVariableNames: 'skillName skillLevel description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Matcher'!

MatcherSkill subclass: #TechSkill
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Matcher'!

!TechSkill class methodsFor: 'as yet unclassified' stamp: 'MattF 3/31/2013 13:05'!
withName: strName level: numLevel description: strDesc

^ self new withName: strName level: numLevel description: strDesc.! !

!TechSkill methodsFor: 'as yet unclassified' stamp: 'MattF 3/31/2013 12:09'!
withName: strName level: numLevel description: strDesc

skillName := strName.
skillLevel := numLevel .
description := strDesc .! !

Object subclass: #MatcherUser
	instanceVariableNames: 'fullName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Matcher'!

!MatcherUser class methodsFor: 'as yet unclassified' stamp: 'HectorGonzalez 4/7/2013 17:48'!
fullName: aFullName
	^self new fullName: aFullName! !

!MatcherUser methodsFor: 'as yet unclassified' stamp: 'HectorGonzalez 4/7/2013 17:49'!
fullName: aFullName
fullName:=aFullName! !
